image: docker:stable

stages:
  - build
  - docker
  - deploy

variables:
  IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
  IMAGE_LATEST: $CI_REGISTRY_IMAGE:latest
  GIT_DEPTH: 1


compile:
  stage: build
  image: pashinin/rust-build:2020-11-14
  script:
    - cargo build --release
    - mv $CARGO_TARGET_DIR/release/app ./app
  tags: [rust-api]
  artifacts:
    paths: [ ./app ]


docker:
  stage: docker
  needs: ["compile"]
  image: docker:stable
  dependencies: [ compile ]
  services:
    - docker:dind
  before_script: [echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY]
  script:
    - docker build --tag $IMAGE .
    - docker push $IMAGE
  only:
    - tags
  tags: [docker]


docker image latest:
  stage: docker
  needs: ["compile"]
  image: docker:stable
  dependencies: [ compile ]
  services:
    - docker:dind
  before_script: [echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY]
  script:
    - docker build --tag $IMAGE_LATEST .
    - docker push $IMAGE_LATEST
  only:
    - master
  tags: [docker]


deploy stable:
  stage: deploy
  variables:
    GIT_STRATEGY: none
  dependencies: []
  script:
    - curl --fail -L -H "Content-Type:application/json" -H "DEPLOY_TOKEN:$DEPLOY_TOKEN" --data "{\"project_name\":\"$CI_PROJECT_NAME\",\"tag\":\"$CI_COMMIT_TAG\"}" https://api.pashinin.com/deploy
  when: manual
  only:
    - tags
  environment:
    name: production
    url: https://api.pashinin.com/files
  tags: [ shell ]


deploy canary:
  stage: deploy
  variables:
    GIT_STRATEGY: none
  dependencies: []
  script:
    - curl --fail -L -H "Content-Type:application/json" -H "DEPLOY_TOKEN:$DEPLOY_TOKEN" --data "{\"project_name\":\"$CI_PROJECT_NAME\",\"tag\":\"$CI_COMMIT_TAG\"}" https://api.pashinin.com/deploy
  only:
    - master
  environment:
    name: canary
    url: https://api.pashinin.com/files-canary
  tags: [ shell ]
